"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ReportedSomaticStructuralVariants(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "reportedStructuralVariantCancer",
        "somaticOrGermline",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_3_0_0 import reports as reports_3_0_0

        return {
            "reportedStructuralVariantCancer": reports_3_0_0.ReportedStructuralVariantCancer,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_3_0_0 import reports as reports_3_0_0

        return {
            "somaticOrGermline": reports_3_0_0.SomaticOrGermline,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_3_0_0 import reports as reports_3_0_0

        return {
            "org.gel.models.report.avro.ReportedStructuralVariantCancer": reports_3_0_0.ReportedStructuralVariantCancer,
            "org.gel.models.report.avro.SomaticOrGermline": reports_3_0_0.SomaticOrGermline,
            "org.gel.models.report.avro.ReportedSomaticStructuralVariants": reports_3_0_0.ReportedSomaticStructuralVariants,
        }

    __slots__ = [
        "reportedStructuralVariantCancer",
        "somaticOrGermline",
    ]

    def __init__(
        self,
        reportedStructuralVariantCancer,
        somaticOrGermline,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_3_0_0.ReportedSomaticStructuralVariants model.

        :param reportedStructuralVariantCancer:
            This is the normal record for one reported variant
        :type reportedStructuralVariantCancer: ReportedStructuralVariantCancer
        :param somaticOrGermline:
            Describe whether this is a somatic or Germline variant
        :type somaticOrGermline: SomaticOrGermline
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "3.0.0"
